package hero.client.importLdap;
/*
*
* ClientUpdateBn.java
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

// utilisation du BnLdap Bean
import hero.interfaces.BnLdap;
import hero.interfaces.BnLdapHome;
import hero.interfaces.BnLdapUtil;

// for J2EE security / for authentication with projectManagerBean
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;

/**
 * Sample for Session Bean.
 * Usage: 
 * java bnldap.ClientUpdateBn
 */
public class ClientUpdateBn {

	/****************************************************************
	            main
	 ***************************************************************/
	public static void main(String args[]) {

		/****************************
			Authentication
		*****************************/
		char[] password = args[1].toCharArray();
		SimpleCallbackHandler handler =
			new SimpleCallbackHandler(args[0], password);
		try {
			LoginContext lc = new LoginContext("TestClient", handler);
			lc.login();
		} catch (LoginException e) {
			System.err.println("Error Client while trying the authentication");
			e.printStackTrace();

		}

		// Connecting to BnLdapHome thru JNDI
		BnLdapHome home = null;
		try {
			home = BnLdapUtil.getHome();
		} catch (Exception e) {
			System.err.println("Cannot lookup BnLdapHome: " + e);
			System.exit(2);
		}

	// BnLdapBean creation
	BnLdap t1 = null;
	try {
	    System.out.println("Create a bean bnLdap");
	    t1 = home.create();
	} catch (Exception e) {
	    System.err.println("Cannot create  BnLdapBean : " + e);
	    System.exit(2);
	}       
          		
	/*******************************
	Import users in bonita database
	********************************/
		
	try {		
	t1.importLdapUsers();	
	} catch (Exception e) {
	    System.err.println("Error Importing users from Ldap to Bonita database: " + e);
	    System.exit(2);
	}		
				
  	
	/**********************    
	   Remove Session Bean: BnLdapbean
	 **********************/		
	try {
	    t1.remove();
	} catch (Exception e) {
	    System.out.println("Exception removing the BnLdap bean: "+e);
	    System.exit(2);
	}
	System.out.println("BnLdapbean removed.");        		
    }                  



}

    
