package hero.client.test;

/*
*
* NodeTests.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.BnProject;
import hero.interfaces.BnProjectHome;
import hero.interfaces.BnProjectValue;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import junit.framework.TestCase;
import junit.framework.TestSuite;

public class ProjectTests extends TestCase {
 
    public ProjectTests(String testname) {
	super(testname);
    }
    
    public static TestSuite suite() {
	return new TestSuite(ProjectTests.class);
    }

    public void setUp() throws Exception {
    }

    public void testCreateProject() throws Exception {
	Context lContext = new InitialContext();
	BnProjectHome lHome = (BnProjectHome) PortableRemoteObject.narrow(
	     lContext.lookup( "ejb/hero/BnProject" ),
	     BnProjectHome.class);
	BnProjectValue pdata=new BnProjectValue();
	pdata.setName("pouet");
	BnProject lProject = lHome.create();
	// Get a new Id of the Test Entity
	String name = lProject.getName();
	System.out.println( "New Entity Id is: " + name );
	
    }

    public void testFindProjectByName() throws Exception {
	Context lContext = new InitialContext();
	BnProjectHome lHome = (BnProjectHome) PortableRemoteObject.narrow(
	     lContext.lookup( "ejb/hero/BnProject" ),
	     BnProjectHome.class);
	BnProject lProject = lHome.create("testFindProject","admin");
	BnProject cProject = lHome.findByName("testFindProject");
	assertTrue(cProject.getName().equals("testFindProject"));
    }

}
