package hero.client.test;

/*
*
* NodeTests.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.BnUser;
import hero.interfaces.BnUserHome;
import hero.interfaces.BnUserValue;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import junit.framework.TestCase;
import junit.framework.TestSuite;

public class UserTests extends TestCase {
 
    public UserTests(String testname) {
	super(testname);
    }
    
    public static TestSuite suite() {
	return new TestSuite(UserTests.class);
    }

    public void setUp() throws Exception {
    }

    public void testCreateUser() throws Exception {
	Context lContext = new InitialContext();
	
	BnUserHome lHome = (BnUserHome) PortableRemoteObject.narrow(
	     lContext.lookup( "ejb/hero/BnUser" ),
	     BnUserHome.class);
	BnUserValue pdata=new BnUserValue();
	pdata.setName("gugusse");
	BnUser lUser = lHome.create(pdata);
	// Get a new Id of the Test Entity
	BnUserValue rdata = lUser.getBnUserValue();
	assertTrue(rdata.getName().equals("gugusse"));
	
    }

}
