package hero.interfaces;

/*
*
* Constants.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

public interface Constants {

	public static final String ADMIN = "admin";
	public static final String INITIALROLE = "InitialRole";

	public interface Pj {
		public static final int INITIAL = 0;
		public static final int STARTED = 1;
		public static final int TERMINATED = 2;

		public static final String[] projectStateName =
			{ "INITIAL", "STARTED", "TERMINATED" };

	}

	// BnEdge constants
	public interface Ed {
		public static final int INITIAL = 0;
		public static final int ACTIVE = 1;
		public static final int ANTICIPATING = 2;
		public static final int DEAD = 3;

		public static final String[] edgeStateName =
			{ "INITIAL", "ACTIVE", "ANTICIPATING", "DEAD" };

		public static final int CONDITION_FALSE = 0;
		public static final int CONDITION_TRUE = 1;
	}

	// BnAgent constants
	public interface Ag {
	    public static final int INACTIVE = 0;
	    public static final int ACTIVE = 1;

	    public static final String[] agentStateName =
			{ "INACTIVE", "ACTIVE"};

	    public static final int ALARM = 0;

	}

	// BnNode constants
	public interface Nd {

		// BnNode states
		public static final int INITIAL = 0;
		public static final int READY = 1;
		public static final int DEAD = 2;
		public static final int ANTICIPABLE = 3;
		public static final int EXPIRED = 4;
		public static final int ANTICIPATING = 5;
		public static final int EXECUTING = 6;
		public static final int EXECUTED = 7;
		public static final int INERROR = 8;
		public static final int FINISHED = 9;
		public static final int TERMINATED = 10;
		public static final int CHECKEDOUT = 11;
		public static final int ANT_SUSPENDED = 12;
		public static final int EXEC_SUSPENDED = 13;
		public static final int BAD_TRANSITION = 14;

		public static final String[] nodeStateName =
			{
				"INITIAL",
				"READY",
				"DEAD",
				"ANTICIPABLE",
				"EXPIRED",
				"ANTICIPATING",
				"EXECUTING",
				"EXECUTED",
				"INERROR",
				"FINISHED",
				"TERMINATED",
				"CHECKEDOUT",
				"ANT_SUSPENDED",
				"EXEC_SUSPENDED",
				"BAD_TRANSITION" };

		// BnNode types

		public static final int AND_JOIN_NODE = 1;
		public static final int OR_JOIN_NODE = 2;
		public static final int AND_JOIN_AUTOMATIC_NODE = 3;
		public static final int OR_JOIN_AUTOMATIC_NODE = 4;
		public static final int SUB_PROCESS_NODE = 5;

		public static final String[] nodeTypeName =
			{
				"NULL_NODE",
				"AND_JOIN_NODE",
				"OR_JOIN_NODE",
				"AND_JOIN_AUTOMATIC_NODE",
				"OR_JOIN_AUTOMATIC_NODE",
				"SUB_PROCESS_NODE",
				};

		// Operations

		public static final int START = 0;
		public static final int TERMINATE = 1;
		public static final int SUSPEND = 2;
		public static final int RESUME = 3;
		public static final int EDGEINITIAL = 4;
		public static final int ANTACTIVE = 5;
		public static final int ACTIVE = 6;
		public static final int CANCEL = 7;

		public static final String[] operationName =
			{
				"START",
				"TERMINATE",
				"SUSPEND",
				"RESUME",
				"EDGEINITIAL",
				"ANTACTIVE",
				"ACTIVE",
				"CANCEL" };

		// Events
		public static final String BEFORESTART = "beforeStart";
		public static final String AFTERSTART = "afterStart";
		public static final String BEFORETERMINATE = "beforeTerminate";
		public static final String AFTERTERMINATE = "afterTerminate";
		public static final String ONCANCEL = "onCancel";
		public static final String ANTICIPATE = "anticipate";

		// Operations mode

		public static final int AUTOMATIC = 0;
		public static final int NO_AUTOMATIC = 1;

		public static final String[] operationMode =
			{ "AUTOMATIC", "NO_AUTOMATIC" };

		// BnNode property
		public static final int TRADITIONAL = 0;
		public static final int FLEXIBLE = 1;

		public static final String[] executionMode =
			{ "TRADITIONAL", "FLEXIBLE" };
	}

	public static int[][] edgeTransition = { 
	    {
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
	    },{
		Ed.INITIAL, //INITIAL
		Ed.INITIAL, // READY
		Ed.DEAD, // DEAD
		Ed.INITIAL, //ANTICIPABLE
		Ed.DEAD, // EXPIRED
		Ed.ANTICIPATING, // ANTICIPATING
		Ed.ANTICIPATING, // EXECUTING
		Ed.ACTIVE, // EXECUTED
		Ed.DEAD, // INERROR
		Ed.ACTIVE, // FINISHED
		Ed.ACTIVE, // TERMINATED
		Ed.ACTIVE, // CHECKEDOUT
		Ed.ANTICIPATING, // ANT SUSPENDED
		Ed.ANTICIPATING, // EXEC_SUSPENDED
	    }
	};
	public static final String AFTERSTART = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "afterStart (Object b,Object n) {\n\n\n"
																+ "}";
	
	public static final String BEFORESTART = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "beforeStart (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String AFTERTERMINATE = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "afterTerminate (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String BEFORETERMINATE = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "beforeTerminate (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String ONCANCEL = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "onCancel (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String ANTICIPATE = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "anticipate (Object b,Object n) {\n\n\n"
																+ "}";
	
	public static final String SUBPROCESS_START = "import hero.interfaces.BnProjectLocal;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "import java.util.Collection;\n"
																+ "import java.util.Iterator;\n"
																+ "import hero.util.StrutsNodeValue;\n"
																+ "import hero.interfaces.Constants.*;"
																+ "beforeStart (Object b,Object n) {\n\n\n"
																+ "hero.interfaces.ProjectSessionLocalHome pHome = (hero.interfaces.ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();"
																+ "hero.interfaces.ProjectSessionLocal subProcess = pHome.create();"
																+ "subProcess.initProject(n.getName());"
																+ "Collection props = n.getBnProperties();"
																+ "Iterator i = props.iterator();"
																+ "while (i.hasNext())"
																+ "{"
																+ "hero.interfaces.BnNodePropertyLocal prop = (hero.interfaces.BnNodePropertyLocal)i.next();"											
																+ "subProcess.setProperty(prop.getTheKey(),prop.getTheValue());"
																+ "}"
																+ "subProcess.setNodesReady();"
																+ "}";
																
	public static final String SUBPROCESS_TERMINATE = "import hero.interfaces.BnProjectLocal;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "import java.util.Collection;\n"
																+ "import java.util.Iterator;\n"
																+ "beforeTerminate (Object b,Object n) {\n\n\n"
																+ "hero.interfaces.UserSessionLocalHome userH = hero.interfaces.UserSessionUtil.getLocalHome();"
																+ "hero.interfaces.UserSessionLocal userSession = userH.create();"
																+ "userSession.terminate(n.getName());"
																+ "hero.interfaces.ProjectSessionLocalHome pHome = (hero.interfaces.ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();"
																+ "hero.interfaces.ProjectSessionLocal subProcess = pHome.create();"
																+ "subProcess.initProject(n.getName());"
																+ "hero.interfaces.ProjectSessionLocal parent = pHome.create();"
																+ "parent.initProject(n.getBnProject().getName());"
																+ "Collection props = subProcess.getProperties();"
																+ "Iterator i = props.iterator();"
																+ "while (i.hasNext())"
																+ "{"
																+ "hero.interfaces.BnProjectPropertyValue prop = (hero.interfaces.BnProjectPropertyValue)i.next();"
																+ "parent.setNodeProperty(n.getName(),prop.getTheKey(),prop.getTheValue(),true);"
																+ "}"
																+ "}";
}
